'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckboxGroup = exports.Checkbox = exports.CheckboxGroupContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckboxGroupContext = exports.CheckboxGroupContext = _react2.default.createContext();

var Provider = CheckboxGroupContext.Provider,
    Consumer = CheckboxGroupContext.Consumer;
var Checkbox = exports.Checkbox = function Checkbox(props) {
  return _react2.default.createElement(
    Consumer,
    null,
    function (_ref) {
      var name = _ref.name,
          checkedValues = _ref.checkedValues,
          onChange = _ref.onChange;

      var optional = {};
      if (checkedValues) {
        optional.checked = checkedValues.indexOf(props.value) >= 0;
      }
      if (typeof onChange === 'function') {
        optional.onChange = onChange.bind(null, props.value);
      }
      return _react2.default.createElement('input', _extends({}, optional, {
        type: 'checkbox',
        name: name
      }, props));
    }
  );
};

Checkbox.defaultProps = {
  value: undefined
};

Checkbox.propTypes = process.env.NODE_ENV !== "production" ? {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool])
} : {};

var CheckboxGroup = exports.CheckboxGroup = function (_React$Component) {
  _inherits(CheckboxGroup, _React$Component);

  function CheckboxGroup() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, CheckboxGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = CheckboxGroup.__proto__ || Object.getPrototypeOf(CheckboxGroup)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      checkedValues: _this.props.checkedValues
    }, _this.isControlledComponent = function () {
      return Boolean(_this.props.checkedValues);
    }, _this.onCheckboxChange = function (checkboxValue, event) {
      var newValues = void 0;
      if (_this.state.checkedValues.includes(checkboxValue)) {
        newValues = _this.state.checkedValues.filter(function (v) {
          return v !== checkboxValue;
        });
      } else {
        newValues = _this.state.checkedValues.concat(checkboxValue);
      }

      if (_this.isControlledComponent()) {
        _this.setState({ checkedValues: _this.props.checkedValues });
      } else {
        _this.setState({ checkedValues: newValues });
      }

      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(newValues, event, _this.props.name);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CheckboxGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.checkedValues) {
        this.setState({
          checkedValues: newProps.checkedValues
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          Component = _props.Component,
          name = _props.name,
          checkedValues = _props.checkedValues,
          onChange = _props.onChange,
          children = _props.children,
          rest = _objectWithoutProperties(_props, ['Component', 'name', 'checkedValues', 'onChange', 'children']);

      return _react2.default.createElement(
        Provider,
        { value: { name: name, checkedValues: checkedValues, onChange: this.onCheckboxChange } },
        _react2.default.createElement(
          Component,
          _extends({ role: 'group' }, rest),
          children
        )
      );
    }
  }]);

  return CheckboxGroup;
}(_react2.default.Component);

CheckboxGroup.defaultProps = {
  name: undefined,
  checkedValues: [],
  onChange: undefined,
  Component: 'div'
};

CheckboxGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  name: _propTypes2.default.string,
  checkedValues: _propTypes2.default.arrayOf(_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool),
  onChange: _propTypes2.default.func,
  children: _propTypes2.default.node.isRequired,
  Component: _propTypes2.default.element
} : {};